package com.sun.net.ssl.internal.www.protocol.https;

import java.security.Permission;
import java.net.ProtocolException;
import java.util.List;
import java.util.Map;
import java.io.InputStream;
import java.io.OutputStream;
import javax.security.cert.X509Certificate;
import javax.net.ssl.SSLPeerUnverifiedException;
import java.security.cert.Certificate;
import java.net.Proxy;
import java.net.MalformedURLException;
import java.io.IOException;
import java.net.URL;
import com.sun.net.ssl.HttpsURLConnection;

public class HttpsURLConnectionOldImpl extends HttpsURLConnection
{
    private DelegateHttpsURLConnection delegate;
    
    HttpsURLConnectionOldImpl(URL url, Handler handler) throws IOException {
        this(url, null, handler);
    }
    
    static URL checkURL(URL url) throws IOException {
        if (url != null && url.toExternalForm().indexOf(10) > -1) {
            throw new MalformedURLException("Illegal character in URL");
        }
        return url;
    }
    
    HttpsURLConnectionOldImpl(URL url, Proxy proxy, Handler handler) throws IOException {
        super(checkURL(url));
        this.delegate = new DelegateHttpsURLConnection(this.url, proxy, handler, this);
    }
    
    protected void setNewClient(URL url) throws IOException {
        this.delegate.setNewClient(url, false);
    }
    
    protected void setNewClient(URL url, boolean useCache) throws IOException {
        this.delegate.setNewClient(url, useCache);
    }
    
    protected void setProxiedClient(URL url, String proxyHost, int proxyPort) throws IOException {
        this.delegate.setProxiedClient(url, proxyHost, proxyPort);
    }
    
    protected void setProxiedClient(URL url, String proxyHost, int proxyPort, boolean useCache) throws IOException {
        this.delegate.setProxiedClient(url, proxyHost, proxyPort, useCache);
    }
    
    public void connect() throws IOException {
        this.delegate.connect();
    }
    
    protected boolean isConnected() {
        return this.delegate.isConnected();
    }
    
    protected void setConnected(boolean connected) {
        this.delegate.setConnected(connected);
    }
    
    public String getCipherSuite() {
        return this.delegate.getCipherSuite();
    }
    
    public Certificate[] getLocalCertificates() {
        return this.delegate.getLocalCertificates();
    }
    
    public Certificate[] getServerCertificates() throws SSLPeerUnverifiedException {
        return this.delegate.getServerCertificates();
    }
    
    public X509Certificate[] getServerCertificateChain() {
        try {
            return this.delegate.getServerCertificateChain();
        }
        catch (SSLPeerUnverifiedException ex) {
            return null;
        }
    }
    
    public synchronized OutputStream getOutputStream() throws IOException {
        return this.delegate.getOutputStream();
    }
    
    public synchronized InputStream getInputStream() throws IOException {
        return this.delegate.getInputStream();
    }
    
    public InputStream getErrorStream() {
        return this.delegate.getErrorStream();
    }
    
    public void disconnect() {
        this.delegate.disconnect();
    }
    
    public boolean usingProxy() {
        return this.delegate.usingProxy();
    }
    
    public Map<String, List<String>> getHeaderFields() {
        return this.delegate.getHeaderFields();
    }
    
    public String getHeaderField(String name) {
        return this.delegate.getHeaderField(name);
    }
    
    public String getHeaderField(int n) {
        return this.delegate.getHeaderField(n);
    }
    
    public String getHeaderFieldKey(int n) {
        return this.delegate.getHeaderFieldKey(n);
    }
    
    public void setRequestProperty(String key, String value) {
        this.delegate.setRequestProperty(key, value);
    }
    
    public void addRequestProperty(String key, String value) {
        this.delegate.addRequestProperty(key, value);
    }
    
    public int getResponseCode() throws IOException {
        return this.delegate.getResponseCode();
    }
    
    public String getRequestProperty(String key) {
        return this.delegate.getRequestProperty(key);
    }
    
    public Map<String, List<String>> getRequestProperties() {
        return this.delegate.getRequestProperties();
    }
    
    public void setInstanceFollowRedirects(boolean instanceFollowRedirects) {
        this.delegate.setInstanceFollowRedirects(instanceFollowRedirects);
    }
    
    public boolean getInstanceFollowRedirects() {
        return this.delegate.getInstanceFollowRedirects();
    }
    
    public void setRequestMethod(String requestMethod) throws ProtocolException {
        this.delegate.setRequestMethod(requestMethod);
    }
    
    public String getRequestMethod() {
        return this.delegate.getRequestMethod();
    }
    
    public String getResponseMessage() throws IOException {
        return this.delegate.getResponseMessage();
    }
    
    public long getHeaderFieldDate(String name, long defaultValue) {
        return this.delegate.getHeaderFieldDate(name, defaultValue);
    }
    
    public Permission getPermission() throws IOException {
        return this.delegate.getPermission();
    }
    
    public URL getURL() {
        return this.delegate.getURL();
    }
    
    public int getContentLength() {
        return this.delegate.getContentLength();
    }
    
    public long getContentLengthLong() {
        return this.delegate.getContentLengthLong();
    }
    
    public String getContentType() {
        return this.delegate.getContentType();
    }
    
    public String getContentEncoding() {
        return this.delegate.getContentEncoding();
    }
    
    public long getExpiration() {
        return this.delegate.getExpiration();
    }
    
    public long getDate() {
        return this.delegate.getDate();
    }
    
    public long getLastModified() {
        return this.delegate.getLastModified();
    }
    
    public int getHeaderFieldInt(String name, int defaultValue) {
        return this.delegate.getHeaderFieldInt(name, defaultValue);
    }
    
    public long getHeaderFieldLong(String name, long defaultValue) {
        return this.delegate.getHeaderFieldLong(name, defaultValue);
    }
    
    public Object getContent() throws IOException {
        return this.delegate.getContent();
    }
    
    public Object getContent(Class[] classes) throws IOException {
        return this.delegate.getContent(classes);
    }
    
    public String toString() {
        return this.delegate.toString();
    }
    
    public void setDoInput(boolean doInput) {
        this.delegate.setDoInput(doInput);
    }
    
    public boolean getDoInput() {
        return this.delegate.getDoInput();
    }
    
    public void setDoOutput(boolean doOutput) {
        this.delegate.setDoOutput(doOutput);
    }
    
    public boolean getDoOutput() {
        return this.delegate.getDoOutput();
    }
    
    public void setAllowUserInteraction(boolean allowUserInteraction) {
        this.delegate.setAllowUserInteraction(allowUserInteraction);
    }
    
    public boolean getAllowUserInteraction() {
        return this.delegate.getAllowUserInteraction();
    }
    
    public void setUseCaches(boolean useCaches) {
        this.delegate.setUseCaches(useCaches);
    }
    
    public boolean getUseCaches() {
        return this.delegate.getUseCaches();
    }
    
    public void setIfModifiedSince(long ifModifiedSince) {
        this.delegate.setIfModifiedSince(ifModifiedSince);
    }
    
    public long getIfModifiedSince() {
        return this.delegate.getIfModifiedSince();
    }
    
    public boolean getDefaultUseCaches() {
        return this.delegate.getDefaultUseCaches();
    }
    
    public void setDefaultUseCaches(boolean defaultUseCaches) {
        this.delegate.setDefaultUseCaches(defaultUseCaches);
    }
    
    protected void finalize() throws Throwable {
        this.delegate.dispose();
    }
    
    public boolean equals(Object obj) {
        return this.delegate.equals(obj);
    }
    
    public int hashCode() {
        return this.delegate.hashCode();
    }
    
    public void setConnectTimeout(int connectTimeout) {
        this.delegate.setConnectTimeout(connectTimeout);
    }
    
    public int getConnectTimeout() {
        return this.delegate.getConnectTimeout();
    }
    
    public void setReadTimeout(int readTimeout) {
        this.delegate.setReadTimeout(readTimeout);
    }
    
    public int getReadTimeout() {
        return this.delegate.getReadTimeout();
    }
    
    public void setFixedLengthStreamingMode(int fixedLengthStreamingMode) {
        this.delegate.setFixedLengthStreamingMode(fixedLengthStreamingMode);
    }
    
    public void setFixedLengthStreamingMode(long fixedLengthStreamingMode) {
        this.delegate.setFixedLengthStreamingMode(fixedLengthStreamingMode);
    }
    
    public void setChunkedStreamingMode(int chunkedStreamingMode) {
        this.delegate.setChunkedStreamingMode(chunkedStreamingMode);
    }
}
